unit matr11;
{$R-}
(* this is designed to operate via matrix *)
(* function simplex has a correct handling with objects *)
(* ࠢ   ᭠ 訡  ᨬ-⮤
                         ⢥ ६*)
{᭮ ᫥ 쥬 , 饭  訡 Borland 7.0}
{ࠢ 訡  뤥   linrefer  colrefer  Box.Read}
{ 쥪 matrix0,       0}
interface

uses
  delp_mem;

const
  zero=1e-6;  { ᯮ SIMPLEX  ஢ન  ࠢ⢮ 0}
  infinit=1.7e38;
type
  tline = array[1..40] of real;
  pline = ^tline;
  tline0 = array[0..40] of real;
  pline0 = ^tline0;

  pvector=^tvector;
  tvector=object
    size:integer;
    p:pline;
    constructor read(var f:text;var error:boolean);
    function get(i:integer):real;
    procedure put(x:real;i:integer);
    procedure CopyFrom(f:tvector);
    constructor CreateZero(s:integer; var outofmem:boolean);
    function ScalarMult(f:tvector):real;
    procedure ConstMult(a:real);
    function InfinitNorm:real;
    function SquareNorm:real;
    destructor Done;
  end;

  pmatrix =^tmatrix;
  tmatrdata=array[1..40] of pline;
  pmatrdata=^tmatrdata;
  tmatrix = object
    size:integer;
    p:pmatrdata;

    constructor read(var f:text;var error:boolean);
    procedure CopyFrom(a:tmatrix);
    constructor CreateZero(s:integer; var outofmem:boolean);
    function det:real; {gives determinant by rotation method}
    function get(i,j:integer):real;
    procedure put(x:real;i,j:integer);
    procedure transpose;
    procedure VectMatrMult(x:tvector; var z:tvector);
    procedure MatrVectMult(x:tvector; var z:tvector);
    destructor Done;
  end;

  pmatrix0 =^tmatrix0;
  tmatrdata0=array[0..40] of pline0;
  pmatrdata0=^tmatrdata0;
  tmatrix0 = object
    size:integer;
    p:pmatrdata0;

    constructor CreateZero(s:integer; var outofmem:boolean);
    function get(i,j:integer):real;
    procedure put(x:real;i,j:integer);
    destructor Done;
  end;

  pbox =^tbox;
  tboxdata=array[1..14] of pline;
  pboxdata=^tboxdata;
  preference=^ reference;
  reference=array[1..14] of integer;
  tbox = object
    m:integer; { ⨪ ࠧ }
    n:integer; { ࠧ ப }
    linrefer:preference; {ଠ  ७㬥樨 ६  ப
                         ( ᮧ  ७㬥樨  )}
    colrefer:preference; {ଠ  ७㬥樨 ६ ⮫殢
                         ( ᮧ  ७㬥樨  )}
    { ᨢ ७㬥樨  ⮫殢/ப  i-⮬  ᮤঠ 
    (   [-32768,32767] ) ਢ易 
    i-⮬ ⮫/ப  }
    p:pboxdata;
    constructor Read(var f:text;var error:boolean);
    procedure Write(var f:text);
    constructor CreateZero(lins,cols:integer; var outofmem:boolean);
    constructor Init(lins,cols:integer; var outofmem:boolean);
    function get(i,j:integer):real;
    {direct-    ॠ樨  linrefer,colrefer}
    procedure put(x:real;i,j:integer);
    {direct-    ॠ樨  linrefer,colrefer}

    procedure CopyFrom(a:tbox);
    destructor Done;
  end;

(* 樨  栬  ࠬ *)
(*       ᮧ ࠭ *)
procedure VectAdd(x,y:tvector;var z:tvector);
procedure MatrMatrMult(a,b:tMatrix; var c:tmatrix);
procedure GradSolve(A:tmatrix;var x:tvector;f:tvector;e:real;var error:boolean);
    (* 蠥 ⥬ ⮤ ᪮३襣 ᪠ *)
Procedure SwapData(var a,b:tvector);
function Simplex(var A1:tbox;var x:tvector;var outofmem,infinity,nosolve:boolean):real;
{ 蠥  ᨬ-⮤
  頥 ⨬쭮 祭 楫 㭪樨

 x-⢥  n
  樥⮢ 楫 㭪樨
    f=C1*X1+...+Cn*Xn+C  -->  MAX
 ।  m+1 ப ६ 'A'  :
    A.p^m+1^1=-C1  ... A.p^m+1^n=-Cn  A.p^m+1^n+1=C
                           :
    ⨢஫, ஬ 樥  ᢮ 童.

 A- (m+1)x(n+1) 樥⮢ ࠭祭 ᮢ饭 
 ࠢ묨 ﬨ.  ப :
    A.p^i^1...A.p^i^n <= A.p^i^n+1           ( 1<=i<=m )
 A 易     ७㬥権.  ࠧ୮ - (m+1)x(n+1)}
implementation

(**************************** object tvector ****************************)
procedure tvector.copyfrom(F:tvector);
var
  i:integer;
begin
  for i:=1 to size do p^[i]:=f.get(i);
end;

constructor tvector.createzero(s:integer;var OutOfMem:boolean);
var
  i,n:integer;
begin
  Outofmem:=true;
  n:=s;
  if (n*sizeof(real)+8>maxavail) then exit;
  Outofmem:=false;
  getmem(p,n*sizeof(real));
  for i:=1 to n do p^[i]:=0;
  size:=n;
end;

constructor tvector.read(var f:text;var error:boolean);
(* creates and reads a vector from file f
   error=true if there's not enough memory or if the formate is invalide
   file formate:
   [n]#13#13[v1]#13...[vn]#13#13
*)
var
  c,cc:char;
  s:string;
  n,i,j:integer;
begin
  error:=true;
  readln(f,s);
  if length(s)=0 then readln(f,s);
  val(s,n,j);
  size:=n;
  if (j<>0) or (size*sizeof(real)+8>maxavail) then exit;
  readln(f,s);
  error:=false;
  getmem(p,size*sizeof(real));
  for j:=1 to size do
  begin
    readln(f,s);
    val(s,p^[j],n);
    if n<>0 then
    begin
      error:=true;
      exit;
    end;
  end;
end;

procedure tvector.constmult(a:real);
var i:integer;
begin
  for i:=1 to size do p^[i]:=a*get(i);
end;

function tvector.squarenorm:real;
var
  i:integer;
  r:real;
begin
  r:=0;
  for i:=1 to size do r:=r+sqr(p^[i]);
  squarenorm:=sqrt(r);
end;

function tvector.infinitnorm:real;
var
  i:integer;
  r:real;
begin
  r:=0;
  for i:=1 to size do
    if abs(p^[i])>r then r:=abs(p^[i]);
  infinitnorm:=r;
end;


procedure tvector.put(x:real;i:integer);
begin
  if (i<=size) and (i>0) then p^[i]:=x;
end;

function tvector.get(i:integer):real;
begin
  get:=p^[i]
end;

function tvector.scalarmult(f:tvector):real;
var
  i:integer;
  r:real;
begin
  r:=0;
  for i:=1 to size do r:=r+get(i)*f.get(i);
  scalarmult:=r;
end;

destructor tvector.Done;
begin
  Freemem(p,size*sizeof(real));
end;
(************************* Object tmatrix *********************)

constructor tmatrix.read(var f:text;var error:boolean);
(* creates and reads a matrix from file f
   error=true if there's not enough memory or if the formate is invalide
   file formate:
   [size of matrix]#13#13[a11]#13...[a1n]#13#13......[an1]#13...[ann]
*)
var
  s:string;
  n,i,j:integer;
begin
  readln(f,s);
  val(s,size,n);
  error:=true;
  if (n<>0) or ((size*sizeof(real)+8)*size+size*sizeof(pline)+8>maxavail) then exit;
  error:=false;
  getmem(p,size*sizeof(pline));
  for i:=1 to size do
  begin
    getmem(p^[i],size*sizeof(real));
    readln(f,s);
    for j:=1 to size do
    begin
      readln(f,s);
      val(s,p^[i]^[j],n);
      if n<>0 then
      begin
        error:=true;
        exit;
      end;
    end;
  end;
end;

procedure tmatrix.CopyFrom(a:tmatrix);
var
  i,j:integer;
begin
  for i:=1 to size do
  begin
    for j:=1 to size do
      p^[i]^[j]:=a.get(i,j);
  end;
end;

constructor tmatrix.CreateZero(s:integer;var outofmem:boolean);
var
  i,j:integer;
begin
  size:=s;
  outofmem:=true;
  if ((size*sizeof(real)+8)*size+size*sizeof(pline)+8>maxavail) then exit;
  outofmem:=false;
  getmem(p,size*sizeof(pline));
  for i:=1 to size do
  begin
    getmem(p^[i],size*sizeof(real));
    for j:=1 to size do
      p^[i]^[j]:=0;
  end;
end;

destructor tmatrix.done;
var
  i,j:integer;
begin
  for i:=1 to size do
  begin
    Freemem(p^[i],size*sizeof(real));
  end;
  Freemem(p,size*sizeof(pline));
end;

procedure tmatrix.VectMatrMult(x:tvector; var z:tvector);
var
  i,j:integer;
  r:real;
begin
  for i:=1 to size do
  begin
    r:=0;
    for j:=1 to size do r:=r+x.get(j)*get(j,i);
    z.put(r,i);
  end;
end;

procedure tmatrix.MatrVectMult(x:tvector ;var z:tvector);
var
  i,j:integer;
  r:real;
begin
  for i:=1 to size do
  begin
    r:=0;
    for j:=1 to size do r:=r+x.get(j)*get(i,j);
    z.put(r,i);
  end;
end;


procedure tmatrix.transpose;
var
  i,j:integer;
  r:real;
begin
  for i:=1 to size-1 do
    for j:=i+1 to size do
    begin
      r:=get(i,j);
      put(get(j,i),i,j);
      put(r,j,i);
    end;
end;


procedure tmatrix.put(x:real;i,j:integer);
begin
  if (i>0) and (j>0) and (i<=size) and (j<=size) then p^[i]^[j]:=x;
end;

function tmatrix.get(i,j:integer):real;
begin
  get:=p^[i]^[j];
end;

function tmatrix.det:real;
  procedure rotation(c,s:real;chosenrow,minor:integer);
  (* makes rotation in given minor,iluminating [A chosenrow,minor]
      minor<chosenrow<=size *)
  var
    i:integer;
    upper,chosen:real;
  begin
    for i:=minor to size do
    begin
      upper:=get(minor,i)*c+get(chosenrow,i)*s;
      if i>minor then chosen:=-get(minor,i)*s+get(chosenrow,i)*c;
      put(upper,minor,i);
      if i>minor then put(chosen,chosenrow,i);
    end;
    put(0,chosenrow,minor);
  end;
var
  c,s,d:real;
  row,minor,i:integer;
begin
  for minor:=1 to size-1 do
    for row:=minor+1 to size do
    begin
      d:=sqrt(sqr(get(minor,minor))+sqr(get(row,minor)));
      c:=get(minor,minor);
      s:=get(row,minor);
      if d>0 then
      begin
        c:=c/d;
        s:=s/d;
        rotation(c,s,row,minor);
      end;
    end;
  d:=1;
  for i:=1 to size do d:=d*get(i,i);
  det:=d;
end;

(************************* Object tmatrix0 *********************)

constructor tmatrix0.CreateZero(s:integer;var outofmem:boolean);
var
  i,j:integer;
begin
  size:=s;
  outofmem:=true;
  if ((longint(size+1)*longint(sizeof(real))+8)*longint(size+1)+
   longint(size+1)*longint(sizeof(pline))+8>maxavail) then exit;
  outofmem:=false;
  getmem(p,(size+1)*sizeof(pline));
  for i:=0 to size do
  begin
    getmem(p^[i],(size+1)*sizeof(real));
    for j:=0 to size do
      p^[i]^[j]:=0;
  end;
end;

destructor tmatrix0.done;
var
  i,j:integer;
begin
  for i:=0 to size do
  begin
    Freemem(p^[i],(size+1)*sizeof(real));
  end;
  Freemem(p,(size+1)*sizeof(pline));
end;

procedure tmatrix0.put(x:real;i,j:integer);
begin
  if (i>=0) and (j>=0) and (i<=size) and (j<=size) then p^[i]^[j]:=x;
end;

function tmatrix0.get(i,j:integer):real;
begin
  get:=p^[i]^[j];
end;

(***************************     TBOX Object   **************************)

constructor tbox.read(var f:text;var error:boolean);
(* creates and reads a box from file f
   error=true if there's not enough memory or if the formate is invalide
   file format:
   [m]#13[n]#13#13[a11]#13...[a1n]#13#13......[am1]#13...[amn]
*)
var
  s:string;
  k,l,i,j:integer;
begin
  readln(f,s);
  val(s,m,k);
  readln(f,s);
  val(s,n,l);
  error:=true;
  if ((k<>0) and (l<>0)) or
    (longint(n*sizeof(real)+8)*longint(m)+
    longint(m)*sizeof(pline)+8>maxavail) then exit;
  error:=false;
  getmem(p,m*sizeof(pline));
  getmem(colrefer,(2+n)*sizeof(integer));
  getmem(linrefer,(2+m)*sizeof(integer));

  for i:=1 to m do
  begin
    getmem(p^[i],n*sizeof(real));

    readln(f,s);
    for j:=1 to n do
    begin
      readln(f,s);
      val(s,p^[i]^[j],k);
      if k<>0 then
      begin
        error:=true;
        exit;
      end;
    end;
    linrefer^[i]:=i;
  end;
  for i:=1 to n do colrefer^[i]:=i;
end;

procedure tbox.Write(var f:text);
(* Writees a box to file f
   file format:
   [m]#13[n]#13#13[a11]#13...[a1n]#13#13......[am1]#13...[amn]
*)
var
  s:string;
  k,l,i,j:integer;
begin
  str(m,s);
  writeln(f,s);
  str(n,s);
  writeln(f,s);
  for i:=1 to m do
  begin
    writeln(f);
    for j:=1 to n do
    begin
      str(p^[i]^[j],s);
      writeln(f,s);
    end;
  end;
end;


procedure tbox.put(x:real;i,j:integer);
begin
    if (i>0) and (j>0) and (i<=m) and (j<=n) then p^[i]^[j]:=x
end;

function tbox.get(i,j:integer):real;
begin
    get:=p^[i]^[j]
end;

procedure tbox.CopyFrom(a:tbox);
var
  i,j,nn,mm:integer;

begin
  nn:=n;
  mm:=m;
  if a.n<nn then nn:=a.n;
  if a.m<mm then mm:=a.m;
  for j:=1 to nn do colrefer^[j]:=a.colrefer^[j];
  for i:=1 to mm do
  begin
    linrefer^[i]:=a.linrefer^[i];
    for j:=1 to nn do
      p^[i]^[j]:=a.get(i,j);
  end;
end;


constructor tbox.CreateZero(lins,cols:integer;var outofmem:boolean);
var
  i,j,rs,is1,ps:longint;
begin
  m:=lins;
  n:=cols;
  outofmem:=true;
  rs:=sizeof(real);
  is1:=sizeof(integer);
  ps:=sizeof(pline);
  if ((n*rs+8)*m+m*(ps+is1)+24
             +is1*n>maxavail) then exit;

  getmem(colrefer,(2+n)*is1);
  getmem(linrefer,(2+m)*is1);
  getmem(p,m*ps);
  outofmem:=false;
  for i:=1 to m do
  begin
    getmem(p^[i],n*rs);
    for j:=1 to n do
      p^[i]^[j]:=0;
    linrefer^[i]:=i;
  end;
  for j:=1 to n do colrefer^[j]:=j;
end;

constructor tbox.Init(lins,cols:integer;var outofmem:boolean);
var
  i,j:integer;
  rs,is1,ps:longint;
begin
  m:=lins;
  n:=cols;
  rs:=sizeof(real);
  is1:=sizeof(integer);
  ps:=sizeof(pline);

  outofmem:=true;
  if ((n*rs+8)*m+m*(ps+is1)+24
             +is1*n>maxavail) then exit;
  outofmem:=false;

  getmem(colrefer,(2+n)*is1);
  getmem(linrefer,(2+m)*is1);
  getmem(p,m*ps);
  for i:=1 to m do
  begin
    getmem(p^[i],n*rs);
  end;
end;

destructor tbox.done;
var
  i,j,rs,is1,ps:longint;
begin
  rs:=sizeof(real);
  is1:=sizeof(integer);
  ps:=sizeof(pline);


  for i:=1 to m do
  begin
    Freemem(p^[i],n*rs);
  end;
  Freemem(p,m*ps);
  Freemem(linrefer,(m+2)*is1);
  Freemem(colrefer,(n+2)*is1);

end;

(*************************** Global Procedures **************************)
Procedure SwapData(var A,B:tvector);
var
  p:pline;
  s:integer;
begin
  p:=A.p;
  A.p:=B.p;
  B.p:=p;

  s:=A.size;
  A.size:=B.size;
  B.size:=s;
end;

procedure VectAdd(x,y:tvector;var z:tvector);
var i:integer;
begin
  for i:=1 to z.size do z.put(x.get(i)+y.get(i),i);
end;


procedure MatrMatrMult(a,b:tMatrix; var c:tmatrix);
var
  i,j,k:integer;
  r:real;
begin
  for i:=1 to a.size do
  begin
    for j:=1 to a.size do
    (* ᪠஢  ⠬ १饩  *)
    begin
      r:=0;
      for k:=1 to a.size do r:=r+a.get(i,k)*b.get(k,j);
      c.put(r,i,j);
    end;
  end;
end;

procedure GradSolve(A:tmatrix;var x:tvector;f:tvector;e:real;var error:boolean);
{ ⥫쭠 㧪 ६ error:
᫨  室 error=true,  뢮 祭 ⥪ 譮⥩ }
var
  show:boolean;
  b:boolean;
  eta,eta_alpha,aa_a_eta,r,xx:tvector;
  AA,AA_A:tmatrix;
  i:integer;
  alpha,d:real;
begin
  show:=error;
  error:=true;
  AA.createzero(A.size,b);
  if b then exit;

  AA_A.createzero(A.size,b);
  if b then
  begin
    AA.done;
    exit;
  end;

  r.createzero(A.size,b);
  if b then
  begin
    AA.done;
    AA_A.done;
    exit;
  end;

  eta_alpha.createzero(A.size,b);
  if b then
  begin
    AA.done;
    AA_A.done;
    r.done;
    exit;
  end;

  eta.createzero(A.size,b);
  if b then
  begin
    AA.done;
    AA_A.done;
    r.done;
    eta_alpha.done;
    exit;
  end;
  aa_a_eta.createzero(A.size,b);
  if b then
  begin
    AA.done;
    AA_A.done;
    r.done;
    eta_alpha.done;
    eta.done;
    exit;
  end;

  xx.createzero(A.size,b);
  if b then
  begin
    AA.done;
    AA_A.done;
    r.done;
    eta_alpha.done;
    eta.done;
    aa_a_eta.done;
    exit;
  end;


  AA.copyfrom(A);
  AA.transpose;
  MatrMatrMult(AA,A,AA_A);
  AA.MatrVectMult(f,eta);
  i:=0;
  b:=false;
  if abs(eta.infinitnorm)<1e-30 then
  begin
    x.copyfrom(f);
    error:=false;
      AA.done;
      AA_A.done;
      r.done;
      eta_alpha.done;
      eta.done;
      aa_a_eta.done;
    exit;
  end;
  repeat
    inc(i);
    AA_A.MatrVectMult(eta,aa_a_eta);
    d:=eta.ScalarMult(aa_a_eta);
    if abs(d)<1e-30 then
    begin
      AA.done;
      AA_A.done;
      r.done;
      eta_alpha.done;
      eta.done;
      aa_a_eta.done;
      exit;
    end;
    alpha:=eta.ScalarMult(eta)/d;
    eta_alpha.copyfrom(eta);
    eta_alpha.ConstMult(alpha);

    VectAdd(x,eta_alpha,xx);
    SwapData(x,xx);
    if i<10 then
    begin
      aa_a_eta.ConstMult(-alpha);
      vectadd(eta,aa_a_eta,xx);
      SwapData(eta,xx);
    end
    else
    begin
      i:=0;
      A.MatrVectMult(x,r);
      r.ConstMult(-1);
      VectAdd(r,f,xx);
      SwapData(r,xx);
      AA.MatrVectMult(r,eta);

    end;
      d:=eta_alpha.infinitnorm;
    if show then writeln(d);
  until (d<e) or (abs(eta.infinitnorm)<1e-30);

  AA.done;
  AA_A.done;
  r.done;
  eta_alpha.done;
  eta.done;
  aa_a_eta.done;
  error:=false;
end;

function Simplex(var A1:tbox;var x:tvector;var outofmem,infinity,nosolve:boolean):real;
{ see interface }
type
  tbular=array[1..1] of boolean;
  pbular=^tbular;
var
i,j,p,q,k,bas,n1,m1,m,n,s:integer;
{s-᫮ ⥫ ࠢ ⥩}
b,goodcol,pluslin,negtop:boolean;
reserved,a_i,a_p,nb_i,nb_p,buffer:pline;
polddata:pboxdata;
r,g:real;
nb,a:tbox;
begin
  m:=a1.m;
  n:=a1.n;
  outofmem:=true;
  nosolve:=false;
  infinity:=false;
  s:=m-1;
  a.createzero(m,n+s,b);
  if b then exit;
  {  s ६, ࠢ⢠   ࠢ .}
    {   ࠢ⢮ ⢮  ६ }

  if maxavail<m*sizeof(boolean) then exit;
  n:=n+s;
  k:=a1.n;
  for i:=1 to a.m-1 do
  begin
   if (a1.get(i,a1.n)<0) then
    begin
      inc(k);
      for j:=1 to a1.n-1 do a.put(-a1.get(i,j),i,j);
      a.put(-1,i,k-1);
      a.put(-a1.get(i,a1.n),i,n);
    end;
    if a1.get(i,a1.n)>=0 then
    begin
      inc(k);
      for j:=1 to a1.n-1 do a.put(a1.get(i,j),i,j);
      a.put(1,i,k-1);
      a.put(a1.get(i,a1.n),i,n);
    end;
    a.colrefer^[k-1]:=k-1;
  end;
  for j:=1 to a1.n-1 do a.put(a1.get(a.m,j),a.m,j);
  a.put(a1.get(a1.m,a1.n),a1.m,n);
  {ਢ  אַ-⨬ }

  for i:=1 to m-1 do a.linrefer^[i]:=-i;
  { ᮡ (⥫쭠) 㬥 ६ . ,
      ⨪.
    K筮, ⠪ ᯮ ⠥ ⮫쪮  ࢮ ⠡}
  nb.Init(m,n,b);
  if b then exit;


  {⮤ ⢥ }
  if sizeof(real)*(n)+8>maxavail then exit;
  getmem(reserved,sizeof(real)*n);
  for j:=1 to n do reserved^[j]:=a.get(m,j);
  for j:=1 to n do
  begin
    r:=0;
    for i:=1 to m-1 do r:=r+a.get(i,j);
    a.put(-r,m,j);
  end;{ 祭 㭪樨 h }
  repeat
    q:=0;
    repeat
      inc(q);
      goodcol:=false;
      if (a.get(m,q)<-zero) and (q<n) then
      begin
        i:=0;
        repeat
          inc(i);
        until (a.get(i,q)>zero) or (i=m);
        if i<m then goodcol:=true;
      end;
    until (( (a.get(m,q)<-zero) and (goodcol)) or (q=n));
    { 롮 饣 ⮫ ⭮⥫쭮  ७㬥樨 }
    if q<n then
    begin
      p:=0;
      r:=1.7e38;
      for i:=1 to m-1 do
      begin
        g:=a.get(i,q);
        if g>zero then
        begin
          g:=a.get(i,n)/g;
          if g<r then
          begin
            r:=g;
            p:=i;
          end;
        end;
      end;{ 롮 饩 ப }
      r:=a.get(p,q);

      a_p:=a.p^[p];
      nb_p:=nb.p^[p];
      for i:=1 to m do
      begin
        a_i:=a.p^[i];
        nb_i:=nb.p^[i];
        for j:=1 to n do
        begin
          if i=p then
          begin
            g:=a_p^[j];
            if j<>q then nb_p^[j]:=g/r else nb_p^[q]:=1/r;
          end
          else
          if j=q then
          begin
            g:=a_i^[q];
            nb_i^[q]:=-g/r;
          end
          else
          begin
            g:=a_i^[j]*r-a_p^[j]*a_i^[q];
            nb_i^[j]:=g/r;
          end;
        end;
      end;
      { ८ࠧ  }
       polddata:=a.p;
      a.p:=nb.p;
      nb.p:=polddata; {  nb - ⠫    }
      k:=a.linrefer^[p];
      a.linrefer^[p]:=a.colrefer^[q];
      a.colrefer^[q]:=k;
    end
    else
    begin
      if abs(a.get(m,n))>zero then
      begin
        nosolve:=true;
        outofmem:=false;
        exit;
     end;
    end;
  until (q=n);
  { ⢥   }

  for j:=1 to n do a.put(0,m,j);
  bas:=0;
  for j:=1 to n do
  begin
    k:=a.colrefer^[j];
    if k>0 then
    begin
      inc(bas);
      a.put(reserved^[k],m,bas);
      for i:=1 to m-1 do a.put(a.get(i,j),i,bas);
      a.colrefer^[bas]:=k;
    end;
  end;{ ⮫   ६ .  襭  ப}
  n1:=bas;
  bas:=0;
  for i:=1 to m do
  begin
    k:=a.linrefer^[i];
    if k>0 then
    begin
      if i<m then
      begin
        for j:=1 to n1-1 do a.put(a.get(m,j)-reserved^[k]*a.get(i,j),m,j);
        a.put(a.get(m,n1)-reserved^[k]*a.get(i,n1),m,n1);
      end;
      inc(bas);
      buffer:=a.p^[bas];
      a.p^[bas]:=a.p^[i];
      a.p^[i]:=buffer;
      a.linrefer^[bas]:=k;
    end;
  end;
  m1:=bas;
   {楫 㭪 ࠦ १  ६
       ⢥ ६ ᭥  }
  pluslin:=false;
  repeat
    q:=0;
    negtop:=false;
    if not(pluslin) then
      repeat
        inc(q);
        goodcol:=false;
        if (a.get(m1,q)<-zero) and (q<n1) then
        begin
          negtop:=true;
          i:=0;
          repeat
            inc(i);
          until (a.get(i,q)>zero) or (i=m1);
          if i<m1 then goodcol:=true;
        end;
      until ((a.get(m1,q)<-zero) and goodcol) or (q=n1)
    else q:=n1;
    { 롮 饣 ⮫ ⭮⥫쭮  ७㬥樨 }

    if q<n1 then
    begin
      p:=0;
      r:=infinit;
      for i:=1 to m1-1 do
      begin
        g:=a.get(i,q);
        if g>zero then
        begin
          g:=a.get(i,n1)/g;
          if g<r then
          begin
            r:=g;
            p:=i;
          end;
        end;
      end;{ 롮 饩 ப }

      r:=a.get(p,q);
      pluslin:=true;
      a_p:=a.p^[p];
      nb_p:=nb.p^[p];
      for i:=m1 downto 1 do
      begin
        a_i:=a.p^[i];
        nb_i:=nb.p^[i];
        if pluslin and (i<m1) then k:=n1 else k:=1;
        for j:=k to n1 do
        begin
          if (i=m1) and (a_i^[j]<0) then pluslin:=false;
          if i=p then
          begin
            g:=a_p^[j];
            if j<>q then nb_p^[j]:=g/r else nb_p^[q]:=1/r;
          end
          else
          if j=q then
          begin
            g:=a_i^[q];
            nb_i^[q]:=-g/r;
          end
          else
          begin
            g:=a_i^[j]*r-a_p^[j]*a_i^[q];
            nb_i^[j]:=g/r;
          end;
        end;
      end;
      { ८ࠧ  }
      polddata:=a.p;
      a.p:=nb.p;
      nb.p:=polddata; {  nb - ⠫    }
      k:=a.linrefer^[p];
      a.linrefer^[p]:=a.colrefer^[q];
      a.colrefer^[q]:=k;
    end
    else
    begin
      if negtop then
      begin
        outofmem:=false;
        nb.done;
        if s>0 then
        begin
          freemem(reserved,sizeof(real)*n);
        end;
        a.done;
        infinity:=true;
        exit;
      end;
    end;
  until q=n1;

  nb.done;
  for j:=1 to n-s-1 do x.p^[j]:=0;
    for i:=1 to m1-1 do
      if (a.linrefer^[i]>0) and (a.linrefer^[i]<n-s) then
        x.p^[a.linrefer^[i]]:=a.get(i,n1);
  if s>0 then
  begin
    freemem(reserved,sizeof(real)*n);
  end;
  simplex:=a.get(m1,n1);
  outofmem:=false;
  a.done;
end;

begin
end.

